Attribute VB_Name = "ComDlg"
Option Explicit

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Function OpenFile(hWind As Long, Optional cMask As String, Optional file As String, Optional cPath As String) As String
    Dim OFName As OPENFILENAME
    If Len(cMask) > 0 Then
        If Asc(Right$(cMask, 1)) > 0 Then
            cMask = cMask & Chr$(0)
        End If
    End If
    'Set the structure size
    OFName.lStructSize = Len(OFName)
    'Set the owner window
    OFName.hwndOwner = hWind
    'Set the application's instance
    OFName.hInstance = App.hInstance
    'Set the filet
    OFName.lpstrFilter = cMask + "  (*.*)" + Chr$(0) + "*.*" + Chr$(0)
    'Create a buffer
    OFName.lpstrFile = Space$(254)
    'Set the maximum number of chars
    OFName.nMaxFile = 255
    'Set the initial directory
    OFName.lpstrInitialDir = cPath
    'Set the dialog title
    OFName.lpstrTitle = " "
    'no extra flags
    OFName.flags = 0
    'Show the 'Open File'-dialog
    If GetOpenFileName(OFName) Then
        OFName.lpstrFile = Trim$(OFName.lpstrFile)
        OpenFile = Left$(OFName.lpstrFile, Len(OFName.lpstrFile) - 1)
    Else
        OpenFile = vbNullString
    End If
End Function

